#include <iostream>
#include <stdio.h>

#include <model.h>
#include <linklist.h>

FILE *code;

void objectgen(Object *o) {
	Method *m;
	Property *p;
	Argument *a;

	// obj = new Object("o->name");
	fputs("\nobj = new Object(\"",code);
	fputs(o->name.c_str(),code);
	fputs("\");\n",code);

	m = (Method*)o->methods.first; 
	while(m) {
		// met = new Method(o->methods.*.name);
		fputs("\nmet = new Method(\"",code);
		fputs(m->name.c_str(),code);
		fputs("\");\n",code);

		a = (Argument*)m->args.first;
		while(a) {
			// arg = new Argument();
			fputs("\narg = new Argument();\n",code);
	
			// arg->name = "a->name"
			fputs("arg->name = \"",code);
			fputs(a->name.c_str(),code);
			fputs("\";\n",code);

			// arg->type = "a->type"
			fputs("arg->type = ",code);
			fputs(	(a->type==INT_VALUE)?"INT_VALUE":
				(a->type==FLOAT_VALUE)?"FLOAT_VALUE":
				(a->type==STRING_VALUE)?"STRING_VALUE":"0",
				code);
			fputs(";\n",code);

			// arg->format = "a->format"
			fputs("arg->format = \"",code);
			fputs(a->format.c_str(),code);
			fputs("\";\n",code);

			// met->args.append( arg );
			fputs("met->args.append( arg );\n",code);
			
			// arg->method = met;
			fputs("arg->method = met;\n",code);

			a = (Argument*)a->next;
		}
		
		// obj->methods.append( met );
		fputs("\nobj->methods.append( met );\n",code);

		// met->parent = obj;
		fputs("met->parent = obj;\n",code);

		m = (Method*)m->next;
	}

	p = (Property*)o->properties.first;
	while(p) {
		// prop = new Property();
		fputs("\nprop = new Property();\n",code);

		// prop->name = "p->name";
		fputs("prop->name = \"",code);
		fputs(p->name.c_str(),code);
		fputs("\";\n",code);

		// prop->type = "p->type";
		fputs("prop->type = ",code);
		fputs(	(p->type==INT_VALUE)?"INT_VALUE":
			(p->type==FLOAT_VALUE)?"FLOAT_VALUE":
			(p->type==STRING_VALUE)?"STRING_VALUE":"0",
			code);
		fputs(";\n",code);

		// prop->format = "p->format"
		fputs("prop->format = \"",code);
		fputs(p->format.c_str(),code);
		fputs("\";\n",code);

		// obj->properties.append( prop );
		fputs("obj->properties.append( prop );\n",code);

		// prop->parent = obj;
		fputs("prop->parent = obj;\n",code);

		p = (Property*)p->next;
	}
	
}



////////////////////////////////////////////////////////
// generates the code to reproduce a tree anywhere
void treegen(Linklist *tree) {
	Object *o, *child;

	code = fopen("introvert_inst.cpp","w"); 
	if(!code) {
		fprintf(stderr,"can't create file introvert.cpp\n");
		return; }

	fputs("#include <model.h>\n\n",code);

	fputs("Linklist introvert_tree;\n",code);

	fputs("void introvert_init() {\n",code);
	fputs("Object *obj;\n",code);
	fputs("Method *met;\n",code);
	fputs("Property *prop;\n",code);
	fputs("Argument *arg;\n\n",code);

	o = (Object*)tree->first;
	while(o) {
		fputs("///////////////////////////\n",code);
		fputs("// instance of ",code);
		fputs(o->name.c_str(),code);
		fputs("\n\n",code);

		objectgen(o);

		child = (Object*)o->childs.first;
		while(child) {
			fputs("\t{\nObject *parent = obj;\n",code);
			objectgen( child );
			fputs("\nparent->childs.append( obj );\n",code);
			fputs("obj = parent;\n\t}\n",code);

			child = (Object*)child->next;
		}

		fputs("\nintrovert_tree.append( obj );\n",code);
		fputs("/////////////////////\n\n",code);

		o = (Object*)o->next;

	}
	fputs("\n}\n",code);
	fclose(code);
}

