
#include <iostream>
#include <cstdio>
#include <stdlib.h>

#include <model.h>

Object::Object(string n)
	:Entry() {
		
	parent = NULL;
	name = n;

}

Object::~Object() {
	Object *otmp;
	Method *mtmp;
	Property *ptmp;

	/* delete all methods */
	while(methods.first) {
		mtmp = (Method*) methods.first;
		mtmp->rem();
		delete mtmp;
	}

	/* delete all properties */
	while(properties.first) {
		ptmp = (Property*) properties.first;
		ptmp->rem();
		delete ptmp;
	}

	/* delete all childs */
	while(childs.first) {
		otmp = (Object*) childs.first;
		otmp->rem();
		delete otmp;
	}

}

void Object::init(void *r) {
	real = r;
}

/////


Method::Method(string n)
	:Entry() {
	parent = NULL;
	name = n;
}

Method::~Method() {
	Argument *tmp;
	
	/* delete all arguments */
	while(args.first) {
		tmp = (Argument*) args.first;
		tmp->rem();
		delete tmp;
	}

//	free(name);
}

/////

Value::Value() {
	type = 0;
}

Value::~Value() { }

bool Value::parse(char *desc) {
	// analize the description and form the value
	bool res = true;
	char *tok;
	char *sep = " \t\n";
	char *str = strdup(desc);

	tok = strtok(str,sep);
	while(tok) {

		if(strcmp( tok, "int") ==0
		|| strcmp( tok, "bool") ==0) {
			format = "%i";
			type = INT_VALUE;
			break;
		} else if(strcmp( tok, "float") ==0) {
			format = "%f";
			type = FLOAT_VALUE;
			break;
		} else if(strcmp( tok, "char") ==0) {
			format = "%s";
			type = STRING_VALUE;
			break;
		}

		tok = strtok(NULL,sep);
	
	}

	if(!type) {
		fprintf(stderr,"ERROR: malformed value %s\n",desc);
		res = false;
	}

	if(!tok) {
		fprintf(stderr,"ERROR: can't find value name in %s\n",desc);
		res = false;
	}

	tok = strtok(NULL,sep);

	if(!tok) {
		fprintf(stderr,"ERROR: no name for %s\n",desc);
		name = "unnamed";
	} else
		name = tok; // implicit cast from char* to c++ string

	free(str);

	fprintf(stderr,"\t\tVALUE \"%s\" of type %s format %s\n", name.c_str(),
		(type==INT_VALUE)?"INT":
		(type==FLOAT_VALUE)?"FLOAT":
		(type==STRING_VALUE)?"STRING":"UNKNOWN", format.c_str());

	return res;
}


/////


Argument::Argument() 
	:Entry(), Value() {
	// TODO: parse the name and recognize type
	method = NULL;
}

Argument::~Argument() { }


/////


Property::Property()
	:Entry(), Value() {
	// TODO: parse the name and recognize type
	parent = NULL;
}

Property::~Property() { }


