
#ifndef __MODEL_H__
#define __MODEL_H__

#include <string>
#include <linklist.h>

class Object;
class Method;
class Value;
class Argument;
class Property;


#define INT_VALUE     1
#define FLOAT_VALUE   2
#define STRING_VALUE  3


class Object: public Entry {
	public:
		Object(string n);
		~Object();
		
		string name;

		void init(void *real);

		Linklist methods;

		Linklist properties;

		Object   *parent;

		Linklist childs;

	private:
		void *real;

};

class Method: public Entry {
	public:
		Method(string n);
		~Method();

		string name;

		Object *parent;

		Linklist args;
};

class Value {
	public:
		Value();
		~Value();

		bool parse(char *desc);
		string name;
		int type;
		string format;
};
		
class Argument: public Entry, public Value {
	public:
		Argument();
		~Argument();

		int flags;

		Method *method;
};

class Property: public Entry, public Value {
	public:
		Property();
		~Property();

		Object *parent;
};

#endif
